diff -purN u-boot-orig/common/cmd_ide.c u-boot/common/cmd_ide.c
--- u-boot-orig/common/cmd_ide.c	2006-08-09 11:54:14.000000000 +0200
+++ u-boot/common/cmd_ide.c	2006-08-09 11:59:08.000000000 +0200
@@ -417,7 +417,8 @@ int do_diskboot (cmd_tbl_t *cmdtp, int f
 		}
 		part = simple_strtoul(++ep, NULL, 16);
 	}
-	if (get_partition_info (ide_dev_desc, part, &info)) {
+	if (get_partition_info (&ide_dev_desc[dev], part, &info)) {
+		printf("error reading partinfo\n");
 		SHOW_BOOT_PROGRESS (-1);
 		return 1;
 	}
diff -purN u-boot-orig/common/cmd_scsi.c u-boot/common/cmd_scsi.c
--- u-boot-orig/common/cmd_scsi.c	2006-08-09 11:54:14.000000000 +0200
+++ u-boot/common/cmd_scsi.c	2006-08-09 11:57:24.000000000 +0200
@@ -243,7 +243,7 @@ int do_scsiboot (cmd_tbl_t *cmdtp, int f
 		}
 		part = simple_strtoul(++ep, NULL, 16);
 	}
-	if (get_partition_info (scsi_dev_desc, part, &info)) {
+	if (get_partition_info (&scsi_dev_desc[dev], part, &info)) {
 		printf("error reading partinfo\n");
 		return 1;
 	}
